//---------------------------------------------------------------------------
#include <vcl.h>
#include "Word_TLB.h"
#pragma hdrstop

#include "WordEg3U.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  MSWord = CoApplication_::Create();
  MSWord.Visible = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  //Should be able to say:
  //  MSWord = NULL;
  //but MS Office apps that have VBA support don't adhere to
  //the lifetime management aspects of the MS COM spec., so...
  MSWord.Quit(&TVariant(False));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
  MSWord.Documents->Add();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
  Selection *Sel = MSWord.Selection;
  Sel->TypeText(WideString("Hello world at "));
  Sel->InsertDateTime(
    &TVariant("dddd, dd MMMM yyyy"),
    &TVariant(False));
  Sel->TypeParagraph();
  Sel->TypeText(WideString(Memo1->Text));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{
  //Obtain Word's doc stats
  Variant DocStats = MSWord.ActiveDocument->BuiltInDocumentProperties;
  ListBox1->Items->Clear();
  ListBox1->Items->Add("Pages: " + DocStats.OlePropertyGet("Item", "Number of pages"));
  ListBox1->Items->Add("Paragraphs: " + DocStats.OlePropertyGet("Item", "Number of paragraphs"));
  ListBox1->Items->Add("Lines: " + DocStats.OlePropertyGet("Item", "Number of lines"));
  ListBox1->Items->Add("Words: " + DocStats.OlePropertyGet("Item", "Number of words"));
  ListBox1->Items->Add("Characters: " + DocStats.OlePropertyGet("Item", "Number of characters"));
}
//---------------------------------------------------------------------------
